function CBDT_OptionsFrame_AcceptButton_OnClick()

    local OptionValue = 0
    
    --Обрабатываем верхний порог DPET-уровня
    OptionValue = tonumber(CBDT_OptionsFrame.DPEtHighThresholdPct:GetText())
    
    if OptionValue then
        OptionValue = OptionValue * 0.01
        
        if OptionValue > CBDT.StageDisplay.DPEtHighThresholdPct.Max then
            CBDT.StageDisplay.DPEtHighThresholdPct.Current = CBDT.StageDisplay.DPEtHighThresholdPct.Max
        elseif OptionValue < CBDT.StageDisplay.DPEtHighThresholdPct.Min then
            CBDT.StageDisplay.DPEtHighThresholdPct.Current = CBDT.StageDisplay.DPEtHighThresholdPct.Min
        else
            CBDT.StageDisplay.DPEtHighThresholdPct.Current = OptionValue
        end
    end
    
    --Обрабатываем нижний порог DPET-уровня
    OptionValue = tonumber(CBDT_OptionsFrame.DPEtLowThresholdPct:GetText())
    
    if OptionValue then
        OptionValue = OptionValue * 0.01
        
        if OptionValue > CBDT.StageDisplay.DPEtHighThresholdPct.Current then
            CBDT.StageDisplay.DPEtLowThresholdPct.Current = CBDT.StageDisplay.DPEtHighThresholdPct.Current
        elseif OptionValue < CBDT.StageDisplay.DPEtHighThresholdPct.Current and OptionValue >= CBDT.StageDisplay.DPEtLowThresholdPct.Min then
            CBDT.StageDisplay.DPEtLowThresholdPct.Current = OptionValue
        end
    end
    
    --Обрабатываем ширину временного окна
    OptionValue = tonumber(CBDT_OptionsFrame.TimeWindow:GetText())
    
    if OptionValue then
        if OptionValue > CBDT.StageDisplay.TimeWindow.Max then
            CBDT.StageDisplay.TimeWindow.Current = CBDT.StageDisplay.TimeWindow.Max
        elseif OptionValue < CBDT.StageDisplay.TimeWindow.Min then
            CBDT.StageDisplay.TimeWindow.Current = CBDT.StageDisplay.TimeWindow.Min
        else
            CBDT.StageDisplay.TimeWindow.Current = OptionValue
        end
    end

    --Обрабатываем количество DPET-уровней
    OptionValue = tonumber(CBDT_OptionsFrame.Stages:GetText())
    
    if OptionValue then
        if OptionValue > CBDT.StageDisplay.Stages.Max then
            CBDT.StageDisplay.Stages.Current = CBDT.StageDisplay.Stages.Max
        elseif OptionValue < CBDT.StageDisplay.Stages.Min then
            CBDT.StageDisplay.Stages.Current = CBDT.StageDisplay.Stages.Min
        else
            CBDT.StageDisplay.Stages.Current = OptionValue
        end
    end
    
    --Обрабатываем длину индикатора DPET-уровней
    OptionValue = tonumber(CBDT_OptionsFrame.StageBarWidth:GetText())
    
    if OptionValue then
        if OptionValue > CBDT.StageDisplay.StageBarWidth.Max then
            CBDT.StageDisplay.StageBarWidth.Current = CBDT.StageDisplay.StageBarWidth.Max
        elseif OptionValue < CBDT.StageDisplay.StageBarWidth.Min then
            CBDT.StageDisplay.StageBarWidth.Current = CBDT.StageDisplay.StageBarWidth.Min
        else
            CBDT.StageDisplay.StageBarWidth.Current = OptionValue
        end
    end
    
    --Обрабатываем высоту индикатора DPET-уровней
    OptionValue = tonumber(CBDT_OptionsFrame.StageBarHeight:GetText())
    
    if OptionValue then
        if OptionValue > CBDT.StageDisplay.StageBarHeight.Max then
            CBDT.StageDisplay.StageBarHeight.Current = CBDT.StageDisplay.StageBarHeight.Max
        elseif OptionValue < CBDT.StageDisplay.StageBarHeight.Min then
            CBDT.StageDisplay.StageBarHeight.Current = CBDT.StageDisplay.StageBarHeight.Min
        else
            CBDT.StageDisplay.StageBarHeight.Current = OptionValue
        end
    end
    
    --Обрабатываем смещение по Х индикатора DPET-уровней
    OptionValue = tonumber(CBDT_OptionsFrame.StageBarOffsetX:GetText())
    
    if OptionValue then
        if OptionValue > CBDT.StageDisplay.StageBarOffsetX.Max then
            CBDT.StageDisplay.StageBarOffsetX.Current = CBDT.StageDisplay.StageBarOffsetX.Max
        elseif OptionValue < CBDT.StageDisplay.StageBarOffsetX.Min then
            CBDT.StageDisplay.StageBarOffsetX.Current = CBDT.StageDisplay.StageBarOffsetX.Min
        else
            CBDT.StageDisplay.StageBarOffsetX.Current = OptionValue
        end
    end
    
    --Обрабатываем смещение по Y индикатора DPET-уровней
    OptionValue = tonumber(CBDT_OptionsFrame.StageBarOffsetY:GetText())
    
    if OptionValue then
        if OptionValue > CBDT.StageDisplay.StageBarOffsetY.Max then
            CBDT.StageDisplay.StageBarOffsetY.Current = CBDT.StageDisplay.StageBarOffsetY.Max
        elseif OptionValue < CBDT.StageDisplay.StageBarOffsetY.Min then
            CBDT.StageDisplay.StageBarOffsetY.Current = CBDT.StageDisplay.StageBarOffsetY.Min
        else
            CBDT.StageDisplay.StageBarOffsetY.Current = OptionValue
        end
    end
    
    --Обрабатываем флаг отображения описания первого DPET-уровня
    OptionValue = CBDT_OptionsFrame.ShowStage1Description:GetChecked()
    
    if OptionValue then
        CBDT.StageDisplay.StageBars[1].Description.Active = true
    else
        CBDT.StageDisplay.StageBars[1].Description.Active = false
    end
    
    --Обрабатываем флаг отображения описания второго DPET-уровня
    OptionValue = CBDT_OptionsFrame.ShowStage2Description:GetChecked()
    
    if OptionValue then
        CBDT.StageDisplay.StageBars[2].Description.Active = true
    else
        CBDT.StageDisplay.StageBars[2].Description.Active = false
    end
    
    --Обрабатываем размер шрифта описания DPET-уровней
    OptionValue = tonumber(CBDT_OptionsFrame.StageDescriptionFontSize:GetText())
    
    if OptionValue then
        if OptionValue > CBDT.StageDisplay.StageDescriptionFontSize.Max then
            CBDT.StageDisplay.StageDescriptionFontSize.Current = CBDT.StageDisplay.StageDescriptionFontSize.Max
        elseif OptionValue < CBDT.StageDisplay.StageDescriptionFontSize.Min then
            CBDT.StageDisplay.StageDescriptionFontSize.Current = CBDT.StageDisplay.StageDescriptionFontSize.Min
        else
            CBDT.StageDisplay.StageDescriptionFontSize.Current = OptionValue
        end
    end
    
    --Обрабатываем софткап углей для случая когда активен нижний порог DPET
    OptionValue = tonumber(CBDT_OptionsFrame.EmberbitsCapLowThreshold:GetText())
    
    if OptionValue then
        if OptionValue > CBDT.StageDisplay.EmberbitsCapLowThreshold.Max then
            CBDT.StageDisplay.EmberbitsCapLowThreshold.Current = CBDT.StageDisplay.EmberbitsCapLowThreshold.Max
        elseif OptionValue < CBDT.StageDisplay.EmberbitsCapLowThreshold.Min then
            CBDT.StageDisplay.EmberbitsCapLowThreshold.Current = CBDT.StageDisplay.EmberbitsCapLowThreshold.Min
        else
            CBDT.StageDisplay.EmberbitsCapLowThreshold.Current = OptionValue
        end
    end
    
    --Обрабатываем софткап углей для случая когда не активен ни один порог DPET
    OptionValue = tonumber(CBDT_OptionsFrame.EmberbitsCapNoThreshold:GetText())
    
    if OptionValue then
        if OptionValue > CBDT.StageDisplay.EmberbitsCapNoThreshold.Max then
            CBDT.StageDisplay.EmberbitsCapNoThreshold.Current = CBDT.StageDisplay.EmberbitsCapNoThreshold.Max
        elseif OptionValue < CBDT.StageDisplay.EmberbitsCapLowThreshold.Current then
            CBDT.StageDisplay.EmberbitsCapNoThreshold.Current = CBDT.StageDisplay.EmberbitsCapLowThreshold.Current
        else
            CBDT.StageDisplay.EmberbitsCapNoThreshold.Current = OptionValue
        end
    end
    
    --Обрабатываем флаг отображения границы времени каста "Стрела Хаоса"
    OptionValue = CBDT_OptionsFrame.ShowCastLine:GetChecked()
    
    if OptionValue then
        CBDT.StageDisplay.DPEtSpellCastLine.Active = true
    else
        CBDT.StageDisplay.DPEtSpellCastLine.Active = false
    end
    
    --Обрабатываем флаг разрешающий/запрешающий использовать стаки "Обратный поток"
    OptionValue = CBDT_OptionsFrame.UseBackdraftStacks:GetChecked()
    
    if OptionValue then
        CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].Backdraft.UseBackdraftStacks = true
    else
        CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].Backdraft.UseBackdraftStacks = false
    end
    
    --Обрабатываем флаг включающий/отключающий функцию "Снести за угли" на слабых целях
    OptionValue = CBDT_OptionsFrame.UseEmberKillOnTrashTargets:GetChecked()
    
    if OptionValue then
        CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].UseEmberKillOnTrashTargets = true
    else
        CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].UseEmberKillOnTrashTargets = false
    end
    
    --Обновляем значения в таблице сохряняемых опций
    CBDT_SavedOptions.DPEtHighThresholdPct          = CBDT.StageDisplay.DPEtHighThresholdPct.Current
    CBDT_SavedOptions.DPEtLowThresholdPct           = CBDT.StageDisplay.DPEtLowThresholdPct.Current
    CBDT_SavedOptions.TimeWindow                    = CBDT.StageDisplay.TimeWindow.Current
    CBDT_SavedOptions.Stages                        = CBDT.StageDisplay.Stages.Current
    
    CBDT_SavedOptions.StageBarWidth                 = CBDT.StageDisplay.StageBarWidth.Current
    CBDT_SavedOptions.StageBarHeight                = CBDT.StageDisplay.StageBarHeight.Current
    CBDT_SavedOptions.StageBarOffsetX               = CBDT.StageDisplay.StageBarOffsetX.Current
    CBDT_SavedOptions.StageBarOffsetY               = CBDT.StageDisplay.StageBarOffsetY.Current
    
    CBDT_SavedOptions.ShowStage1Description         = CBDT.StageDisplay.StageBars[1].Description.Active
    CBDT_SavedOptions.ShowStage2Description         = CBDT.StageDisplay.StageBars[2].Description.Active
    
    CBDT_SavedOptions.StageDescriptionFontSize      = CBDT.StageDisplay.StageDescriptionFontSize.Current
    
    CBDT_SavedOptions.ShowCastLine                  = CBDT.StageDisplay.DPEtSpellCastLine.Active
    
    CBDT_SavedOptions.UseBackdraftStacks            = CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].Backdraft.UseBackdraftStacks

    CBDT_SavedOptions.UseEmberKillOnTrashTargets    = CBDT.Player.PlayerInfo[CBDT.WARLOCK_DESTRUCTION].UseEmberKillOnTrashTargets

    CBDT_SavedOptions.EmberbitsCapLowThreshold      = CBDT.StageDisplay.EmberbitsCapLowThreshold.Current
    CBDT_SavedOptions.EmberbitsCapNoThreshold       = CBDT.StageDisplay.EmberbitsCapNoThreshold.Current
    
    CBDT_SavedOptions.SelectedChaosBoltSoundIndex   = CBDT.SoundNotification.SelectedChaosBoltSoundIndex
    CBDT_SavedOptions.SelectedShadowburnSoundIndex  = CBDT.SoundNotification.SelectedShadowburnSoundIndex
    CBDT_SavedOptions.SelectedSoundChannel          = CBDT.SoundNotification.SelectedSoundChannel
    
    CBDT.StageDisplay:Init()
    CBDT_OptionsFrame:Hide()
end

function CBDT_OptionsFrame_CancelButton_OnClick()
    CBDT_OptionsFrame:Hide()
end

--Chaos Bolt drop down menu functions
function CBDT_OptionsFrame_DropDownChaosBoltSoundMenu_OnSelect(self)
    CBDT.SoundNotification.SelectedChaosBoltSoundIndex = self:GetID()
    UIDropDownMenu_SetSelectedID(CBDT_OptionsFrame_DropDownChaosBoltSoundMenu, CBDT.SoundNotification.SelectedChaosBoltSoundIndex)
    PlaySoundFile(CBDT.SoundNotification.Sounds[CBDT.SoundNotification.SelectedChaosBoltSoundIndex].SoundPath, CBDT.SoundNotification.Channels[CBDT.SoundNotification.SelectedSoundChannel])
end

function CBDT_OptionsFrame_DropDownChaosBoltSoundMenu_OnLoad()
   local info = {}

   for SoundIndex in ipairs(CBDT.SoundNotification.Sounds) do
       info        = UIDropDownMenu_CreateInfo()
       info.text   = CBDT.SoundNotification.Sounds[SoundIndex].SoundName
       info.func   = CBDT_OptionsFrame_DropDownChaosBoltSoundMenu_OnSelect
       UIDropDownMenu_AddButton(info)
   end

   if not UIDropDownMenu_GetSelectedID(CBDT_OptionsFrame_DropDownChaosBoltSoundMenu) then
       UIDropDownMenu_SetSelectedID(CBDT_OptionsFrame_DropDownChaosBoltSoundMenu, CBDT.SoundNotification.SelectedChaosBoltSoundIndex)
   end
end

--Shadowburn drop down menu functions
function CBDT_OptionsFrame_DropDownShadowburnSoundMenu_OnSelect(self)
    CBDT.SoundNotification.SelectedShadowburnSoundIndex = self:GetID()
    UIDropDownMenu_SetSelectedID(CBDT_OptionsFrame_DropDownShadowburnSoundMenu, CBDT.SoundNotification.SelectedShadowburnSoundIndex)
    PlaySoundFile(CBDT.SoundNotification.Sounds[CBDT.SoundNotification.SelectedShadowburnSoundIndex].SoundPath, CBDT.SoundNotification.Channels[CBDT.SoundNotification.SelectedSoundChannel])
end

function CBDT_OptionsFrame_DropDownShadowburnSoundMenu_OnLoad()
   local info = {}

   for SoundIndex in ipairs(CBDT.SoundNotification.Sounds) do
       info        = UIDropDownMenu_CreateInfo()
       info.text   = CBDT.SoundNotification.Sounds[SoundIndex].SoundName
       info.func   = CBDT_OptionsFrame_DropDownShadowburnSoundMenu_OnSelect
       UIDropDownMenu_AddButton(info)
   end

   if not UIDropDownMenu_GetSelectedID(CBDT_OptionsFrame_DropDownShadowburnSoundMenu) then
       UIDropDownMenu_SetSelectedID(CBDT_OptionsFrame_DropDownShadowburnSoundMenu, CBDT.SoundNotification.SelectedShadowburnSoundIndex)
   end
end

--Sound channel drop down menu functions
function CBDT_OptionsFrame_DropDownSoundChannelMenu_OnSelect(self)
    CBDT.SoundNotification.SelectedSoundChannel = self:GetID()
    UIDropDownMenu_SetSelectedID(CBDT_OptionsFrame_DropDownSoundChannelMenu, CBDT.SoundNotification.SelectedSoundChannel)
    PlaySoundFile(CBDT.SoundNotification.Sounds[CBDT.SoundNotification.SelectedSoundIndex].SoundPath, CBDT.SoundNotification.Channels[CBDT.SoundNotification.SelectedSoundChannel])
end

function CBDT_OptionsFrame_DropDownSoundChannelMenu_OnLoad()
    local info = {}

    for ChannelIndex in ipairs(CBDT.SoundNotification.Channels) do
        info        = UIDropDownMenu_CreateInfo()
        info.text   = CBDT.SoundNotification.Channels[ChannelIndex]
        info.func   = CBDT_OptionsFrame_DropDownSoundChannelMenu_OnSelect
        UIDropDownMenu_AddButton(info)
    end

    if not UIDropDownMenu_GetSelectedID(CBDT_OptionsFrame_DropDownSoundChannelMenu) then
        UIDropDownMenu_SetSelectedID(CBDT_OptionsFrame_DropDownSoundChannelMenu, CBDT.SoundNotification.SelectedSoundChannel)
    end
end
